diff --git a/hardware/OpenZWave.cpp b/hardware/OpenZWave.cpp
index 147ed0564d..15d7100361 100644
--- a/hardware/OpenZWave.cpp
+++ b/hardware/OpenZWave.cpp
@@ -5491,48 +5515,48 @@ namespace http {
 			}
 		}
 
-		void CWebServer::ZWaveCPSaveConfig(WebEmSession & session, const request& req, reply & rep)
+		void CWebServer::ZWaveCPSaveConfig(WebEmSession& session, const request& req, reply& rep)
 		{
-			CDomoticzHardwareBase *pHardware = m_mainworker.GetHardware(m_ZW_Hwidx);
+			CDomoticzHardwareBase* pHardware = m_mainworker.GetHardware(m_ZW_Hwidx);
 			if (pHardware != NULL)
 			{
 				if (pHardware->HwdType == HTYPE_OpenZWave)
 				{
-					COpenZWave *pOZWHardware = (COpenZWave*)pHardware;
+					COpenZWave* pOZWHardware = (COpenZWave*)pHardware;
 					std::lock_guard<std::mutex> l(pOZWHardware->m_NotificationMutex);
 					reply::set_content(&rep, pOZWHardware->m_ozwcp.SaveConfig());
 				}
 			}
 		}
-		void CWebServer::ZWaveCPGetTopo(WebEmSession & session, const request& req, reply & rep)
+		void CWebServer::ZWaveCPGetTopo(WebEmSession& session, const request& req, reply& rep)
 		{
-			CDomoticzHardwareBase *pHardware = m_mainworker.GetHardware(m_ZW_Hwidx);
+			CDomoticzHardwareBase* pHardware = m_mainworker.GetHardware(m_ZW_Hwidx);
 			if (pHardware != NULL)
 			{
 				if (pHardware->HwdType == HTYPE_OpenZWave)
 				{
-					COpenZWave *pOZWHardware = (COpenZWave*)pHardware;
+					COpenZWave* pOZWHardware = (COpenZWave*)pHardware;
 					std::lock_guard<std::mutex> l(pOZWHardware->m_NotificationMutex);
 					reply::set_content(&rep, pOZWHardware->m_ozwcp.GetCPTopo());
 					reply::add_header_attachment(&rep, "topo.xml");
 				}
 			}
 		}
-		void CWebServer::ZWaveCPGetStats(WebEmSession & session, const request& req, reply & rep)
+		void CWebServer::ZWaveCPGetStats(WebEmSession& session, const request& req, reply& rep)
 		{
-			CDomoticzHardwareBase *pHardware = m_mainworker.GetHardware(m_ZW_Hwidx);
+			CDomoticzHardwareBase* pHardware = m_mainworker.GetHardware(m_ZW_Hwidx);
 			if (pHardware != NULL)
 			{
 				if (pHardware->HwdType == HTYPE_OpenZWave)
 				{
-					COpenZWave *pOZWHardware = (COpenZWave*)pHardware;
+					COpenZWave* pOZWHardware = (COpenZWave*)pHardware;
 					std::lock_guard<std::mutex> l(pOZWHardware->m_NotificationMutex);
 					reply::set_content(&rep, pOZWHardware->m_ozwcp.GetCPStats());
 					reply::add_header_attachment(&rep, "stats.xml");
 				}
 			}
 		}
-		void CWebServer::ZWaveCPSceneCommand(WebEmSession & session, const request& req, reply & rep)
+		void CWebServer::ZWaveCPSceneCommand(WebEmSession& session, const request& req, reply& rep)
 		{
 			if (req.content.find("fun") == std::string::npos)
 				return;
@@ -5544,19 +5568,19 @@ namespace http {
 			std::string sLabel = request::findValue(&values, "label");
 			std::string sArg3 = (!sVid.empty()) ? sVid : sLabel;
 			std::string sArg4 = request::findValue(&values, "value");
-			CDomoticzHardwareBase *pHardware = m_mainworker.GetHardware(m_ZW_Hwidx);
+			CDomoticzHardwareBase* pHardware = m_mainworker.GetHardware(m_ZW_Hwidx);
 			if (pHardware != NULL)
 			{
 				if (pHardware->HwdType == HTYPE_OpenZWave)
 				{
-					COpenZWave *pOZWHardware = (COpenZWave*)pHardware;
+					COpenZWave* pOZWHardware = (COpenZWave*)pHardware;
 					std::lock_guard<std::mutex> l(pOZWHardware->m_NotificationMutex);
 					reply::set_content(&rep, pOZWHardware->m_ozwcp.DoSceneCommand(sArg1, sArg2, sArg3, sArg4));
 				}
 			}
 		}
 
-		void CWebServer::ZWaveCPTestHeal(WebEmSession & session, const request& req, reply & rep)
+		void CWebServer::ZWaveCPTestHeal(WebEmSession& session, const request& req, reply& rep)
 		{
 			if (session.rights != 2)
 			{
@@ -5570,14 +5594,14 @@ namespace http {
 			request::makeValuesFromPostContent(&req, values);
 			std::string sFun = request::findValue(&values, "fun");
 
-			CDomoticzHardwareBase *pHardware = m_mainworker.GetHardware(m_ZW_Hwidx);
+			CDomoticzHardwareBase* pHardware = m_mainworker.GetHardware(m_ZW_Hwidx);
 			if (pHardware == NULL)
 				return;
-			COpenZWave *pOZWHardware = (COpenZWave*)pHardware;
+			COpenZWave* pOZWHardware = (COpenZWave*)pHardware;
 
 			if (pHardware->HwdType == HTYPE_OpenZWave)
 			{
-				COpenZWave *pOZWHardware = (COpenZWave*)pHardware;
+				COpenZWave* pOZWHardware = (COpenZWave*)pHardware;
 				std::lock_guard<std::mutex> l(pOZWHardware->m_NotificationMutex);
 
 				if (sFun == "test")
@@ -5605,7 +5629,7 @@ namespace http {
 			}
 		}
 
-		void CWebServer::Cmd_ZWaveSetUserCodeEnrollmentMode(WebEmSession & session, const request& req, Json::Value &root)
+		void CWebServer::Cmd_ZWaveSetUserCodeEnrollmentMode(WebEmSession& session, const request& req, Json::Value& root)
 		{
 			if (session.rights != 2)
 			{
@@ -5616,17 +5640,17 @@ namespace http {
 			std::string idx = request::findValue(&req, "idx");
 			if (idx == "")
 				return;
-			CDomoticzHardwareBase *pHardware = m_mainworker.GetHardware(atoi(idx.c_str()));
+			CDomoticzHardwareBase* pHardware = m_mainworker.GetHardware(atoi(idx.c_str()));
 			if (pHardware != NULL)
 			{
-				COpenZWave *pOZWHardware = (COpenZWave*)pHardware;
+				COpenZWave* pOZWHardware = (COpenZWave*)pHardware;
 				root["status"] = "OK";
 				root["title"] = "SetUserCodeEnrollmentMode";
 				pOZWHardware->SetUserCodeEnrollmentMode();
 			}
 		}
 
-		void CWebServer::Cmd_ZWaveRemoveUserCode(WebEmSession & session, const request& req, Json::Value &root)
+		void CWebServer::Cmd_ZWaveRemoveUserCode(WebEmSession& session, const request& req, Json::Value& root)
 		{
 			if (session.rights != 2)
 			{
@@ -5650,10 +5674,10 @@ namespace http {
 				int hwid = atoi(result[0][0].c_str());
 				unsigned int homeID = static_cast<unsigned int>(std::stoul(result[0][1]));
 				int nodeID = atoi(result[0][2].c_str());
-				CDomoticzHardwareBase *pHardware = m_mainworker.GetHardware(hwid);
+				CDomoticzHardwareBase* pHardware = m_mainworker.GetHardware(hwid);
 				if (pHardware != NULL)
 				{
-					COpenZWave *pOZWHardware = (COpenZWave*)pHardware;
+					COpenZWave* pOZWHardware = (COpenZWave*)pHardware;
 					if (!pOZWHardware->RemoveUserCode(homeID, nodeID, iCodeIndex))
 						return;
 					root["status"] = "OK";
@@ -5662,7 +5686,7 @@ namespace http {
 			}
 		}
 
-		void CWebServer::Cmd_ZWaveGetNodeUserCodes(WebEmSession & session, const request& req, Json::Value &root)
+		void CWebServer::Cmd_ZWaveGetNodeUserCodes(WebEmSession& session, const request& req, Json::Value& root)
 		{
 			std::string idx = request::findValue(&req, "idx");
 			if (idx == "")
@@ -5675,10 +5699,10 @@ namespace http {
 				int hwid = atoi(result[0][0].c_str());
 				unsigned int homeID = static_cast<unsigned int>(std::stoul(result[0][1]));
 				int nodeID = atoi(result[0][2].c_str());
-				CDomoticzHardwareBase *pHardware = m_mainworker.GetHardware(hwid);
+				CDomoticzHardwareBase* pHardware = m_mainworker.GetHardware(hwid);
 				if (pHardware != NULL)
 				{
-					COpenZWave *pOZWHardware = (COpenZWave*)pHardware;
+					COpenZWave* pOZWHardware = (COpenZWave*)pHardware;
 					if (!pOZWHardware->GetNodeUserCodes(homeID, nodeID, root))
 						return;
 					root["status"] = "OK";
diff --git a/hardware/openzwave/Bitfield.h b/hardware/openzwave/Bitfield.h
index 4c0797723c..4cb1ad123f 100644
--- a/hardware/openzwave/Bitfield.h
+++ b/hardware/openzwave/Bitfield.h
@@ -33,127 +33,51 @@
 
 namespace OpenZWave
 {
-	class OPENZWAVE_EXPORT Bitfield
+class OPENZWAVE_EXPORT Bitfield
+{
+	friend class Iterator;
+
+public:
+	Bitfield();
+	Bitfield(uint32 value);
+	~Bitfield();
+	bool Set( uint8 _idx );
+	bool Clear( uint8 _idx );
+	bool IsSet( uint8 _idx ) const;
+	uint32 GetNumSetBits() const;
+	uint32 GetValue() const;
+	bool SetValue(uint32 val);
+	uint32 GetSize() const;
+	class Iterator
 	{
-		friend class Iterator;
+		friend class Bitfield;
 
 	public:
-		Bitfield():m_numSetBits(0){}
-		~Bitfield(){}
-
-		void Set( uint32 _idx )
-		{
-			if( !IsSet(_idx) )
-			{
-				uint32 newSize = (_idx>>5)+1;
-				if( newSize > m_bits.size() )
-				{
-					m_bits.resize( newSize, 0 );
-				}
-				m_bits[_idx>>5] |= (1<<(_idx&0x1f));
-				++m_numSetBits;
-			}
-		}
-
-		void Clear( uint32 _idx )
-		{
-			if( IsSet(_idx) )
-			{
-				m_bits[_idx>>5] &= ~(1<<(_idx&0x1f));
-				--m_numSetBits;
-			}
-		}
-
-		bool IsSet( uint32 _idx )const
-		{
-			if( (_idx>>5) < m_bits.size() )
-			{
-				return( ( m_bits[_idx>>5] & (1<<(_idx&0x1f)) ) !=0 );
-			}
-			return false;
-		}
-
-		uint32 GetNumSetBits()const{ return m_numSetBits; }
-
-		class Iterator
-		{
-			friend class Bitfield;
-
-		public:
-			uint32 operator *() const
-			{
-				return m_idx;
-			}
-
-			Iterator& operator++()
-			{
-				// Search forward to next set bit
-				NextSetBit();
-			  	return *this;
-			}
+		uint32 operator *() const;
+		Iterator& operator++();
+		Iterator operator++(int);
 
-			Iterator operator++(int)
-			{
-				Iterator tmp = *this;
-				++tmp;
-				return tmp;
-			}
-
-			bool operator ==(const Iterator &rhs)
-			{
-				return m_idx == rhs.m_idx;
-			}
-
-			bool operator !=(const Iterator &rhs)
-			{
-				return m_idx != rhs.m_idx;
-			}
-
-		private:
-			Iterator( Bitfield const* _bitfield, uint32 _idx ): m_idx( _idx ), m_bitfield( _bitfield )
-			{
-				// If this is a begin iterator, move it to the first set bit
-				if( ( _idx == 0 ) && ( !m_bitfield->IsSet(0) ) )
-				{
-					NextSetBit();
-				}
-			}
+		bool operator ==(const Iterator &rhs);
+		bool operator !=(const Iterator &rhs);
+	private:
+		Iterator( Bitfield const* _bitfield, uint32 _idx );
 
-			void NextSetBit()
-			{
-				while( ((++m_idx)>>5)<m_bitfield->m_bits.size() )
-				{
-					// See if there are any bits left to find in the current uint32
-					if( ( m_bitfield->m_bits[m_idx>>5] & ~((1<<(m_idx&0x1f))-1) ) == 0 )
-					{
-						// No more bits - move on to next uint32 (or rather one less than 
-						// the next uint32 because of the preincrement in the while statement)
-						m_idx = (m_idx&0xffffffe0)+31;
-					}
-					else
-					{
-						if( (m_bitfield->m_bits[m_idx>>5] & (1<<(m_idx&0x1f))) !=0 )
-						{
-							// This bit is set
-							return;
-						}
-					}
-				}
-			}
+		void NextSetBit();
 
-			uint32				m_idx;
-			Bitfield const*		m_bitfield;
-		};
+		uint32				m_idx;
+		Bitfield const*		m_bitfield;
+	};
 
-		Iterator Begin()const{ return Iterator( this, 0 ); }
-		Iterator End()const{ return Iterator( this, (uint32) m_bits.size()<<5 ); }
+	Iterator Begin() const;
+	Iterator End() const;
 
-	private:
-OPENZWAVE_EXPORT_WARNINGS_OFF
-		vector<uint32>	m_bits;
-OPENZWAVE_EXPORT_WARNINGS_ON
-		uint32			m_numSetBits;
-	};
+private:
+	OPENZWAVE_EXPORT_WARNINGS_OFF
+	vector<uint32>	m_bits;
+	OPENZWAVE_EXPORT_WARNINGS_ON
+	uint32			m_numSetBits;
+	uint32			m_value;
+};
 } // namespace OpenZWave
 
 #endif
diff --git a/hardware/openzwave/CompatOptionManager.h b/hardware/openzwave/CompatOptionManager.h
new file mode 100644
index 0000000000..c94a1e3eae
--- /dev/null
+++ b/hardware/openzwave/CompatOptionManager.h
@@ -0,0 +1,141 @@
+//-----------------------------------------------------------------------------
+//
+//	CompatOptionManager.h
+//
+//	Handles Compatibility Flags in Config Files
+//
+//	Copyright (c) 2019 Justin Hammond <justin@dynam.ac>
+//
+//	SOFTWARE NOTICE AND LICENSE
+//
+//	This file is part of OpenZWave.
+//
+//	OpenZWave is free software: you can redistribute it and/or modify
+//	it under the terms of the GNU Lesser General Public License as published
+//	by the Free Software Foundation, either version 3 of the License,
+//	or (at your option) any later version.
+//
+//	OpenZWave is distributed in the hope that it will be useful,
+//	but WITHOUT ANY WARRANTY; without even the implied warranty of
+//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//	GNU Lesser General Public License for more details.
+//
+//	You should have received a copy of the GNU Lesser General Public License
+//	along with OpenZWave.  If not, see <http://www.gnu.org/licenses/>.
+//
+//-----------------------------------------------------------------------------
+
+#ifndef CPP_SRC_COMPATOPTIONMANAGER_H_
+#define CPP_SRC_COMPATOPTIONMANAGER_H_
+
+#include "Defs.h"
+#include "tinyxml.h"
+
+#include <map>
+
+namespace OpenZWave {
+
+enum CompatOptionFlags
+{
+	COMPAT_FLAG_GETSUPPORTED,
+	COMPAT_FLAG_OVERRIDEPRECISION,
+	COMPAT_FLAG_FORCEVERSION,
+	COMPAT_FLAG_CREATEVARS,
+	COMPAT_FLAG_REFRESHONWAKEUP,
+	COMPAT_FLAG_BASIC_IGNOREREMAPPING,
+	COMPAT_FLAG_BASIC_SETASREPORT,
+	COMPAT_FLAG_BASIC_MAPPING,
+	COMPAT_FLAG_COLOR_IDXBUG,
+	COMPAT_FLAG_MCA_FORCEINSTANCES,
+	COMPAT_FLAG_MI_MAPROOTTOENDPOINT,
+	COMPAT_FLAG_MI_FORCEUNIQUEENDPOINTS,
+	COMPAT_FLAG_MI_IGNMCCAPREPORTS,
+	COMPAT_FLAG_MI_ENDPOINTHINT,
+	COMPAT_FLAG_TSSP_BASE,
+	COMPAT_FLAG_TSSP_ALTTYPEINTERPRETATION,
+	COMPAT_FLAG_UC_EXPOSERAWVALUE,
+	COMPAT_FLAG_VERSION_GETCLASSVERSION,
+	COMPAT_FLAG_WAKEUP_DELAYNMI,
+	STATE_FLAG_CCVERSION,
+	STATE_FLAG_STATIC_REQUESTS,
+	STATE_FLAG_AFTERMARK,
+	STATE_FLAG_ENCRYPTED,
+	STATE_FLAG_INNIF,
+	STATE_FLAG_CS_SCENECOUNT,
+	STATE_FLAG_CS_CLEARTIMEOUT,
+	STATE_FLAG_CCS_CHANGECOUNTER,
+	STATE_FLAG_COLOR_CHANNELS,
+	STATE_FLAG_DOORLOCK_TIMEOUT,
+	STATE_FLAG_DOORLOCK_INSIDEMODE,
+	STATE_FLAG_DOORLOCK_OUTSIDEMODE,
+	STATE_FLAG_DOORLOCK_TIMEOUTMINS,
+	STATE_FLAG_DOORLOCK_TIMEOUTSECS,
+	STATE_FLAG_DOORLOCKLOG_MAXRECORDS,
+	STATE_FLAG_USERCODE_COUNT,
+};
+
+enum CompatOptionFlagType
+{
+	COMPAT_FLAG_TYPE_BOOL,
+	COMPAT_FLAG_TYPE_BYTE,
+	COMPAT_FLAG_TYPE_SHORT,
+	COMPAT_FLAG_TYPE_INT
+};
+
+enum CompatOptionType
+{
+	CompatOptionType_Compatibility,
+	CompatOptionType_Discovery
+};
+
+struct CompatOptionFlagStorage {
+	CompatOptionFlags flag;
+	CompatOptionFlagType type;
+	bool changed;
+	union {
+		bool valBool;
+		uint8_t valByte;
+		uint16_t valShort;
+		uint32_t valInt;
+	};
+};
+
+struct CompatOptionFlagDefintions {
+	string name;
+	CompatOptionFlags flag;
+	CompatOptionFlagType type;
+};
+
+class CommandClass;
+class CompatOptionManager {
+public:
+	CompatOptionManager(CompatOptionType type, CommandClass *cc);
+	virtual ~CompatOptionManager();
+
+	void SetNodeAndCC(uint8_t node, uint8_t cc);
+	void EnableFlag(CompatOptionFlags flag, uint32_t defaultval);
+
+	void ReadXML( TiXmlElement const* _ccElement );
+	void WriteXML( TiXmlElement* _ccElement );
+	bool GetFlagBool(CompatOptionFlags flag) const;
+	uint8_t GetFlagByte(CompatOptionFlags flag) const;
+	uint16_t GetFlagShort(CompatOptionFlags flag) const;
+	uint32_t GetFlagInt(CompatOptionFlags flag) const;
+	bool SetFlagBool(CompatOptionFlags flag, bool value);
+	bool SetFlagByte(CompatOptionFlags flag, uint8_t value);
+	bool SetFlagShort(CompatOptionFlags flag, uint16_t value);
+	bool SetFlagInt(CompatOptionFlags flag, uint32_t value);
+private:
+	string GetFlagName(CompatOptionFlags flag) const;
+	string GetXMLTagName();
+	map<CompatOptionFlags, CompatOptionFlagStorage> m_CompatVals;
+	map<string, CompatOptionFlags> m_enabledCompatFlags;
+	CommandClass *m_owner;
+	CompatOptionType m_comtype;
+	CompatOptionFlagDefintions *m_availableFlags;
+	uint32_t m_availableFlagsCount;
+};
+
+} /* namespace OpenZWave */
+
+#endif /* CPP_SRC_COMPATOPTIONMANAGER_H_ */
diff --git a/hardware/openzwave/DNSThread.h b/hardware/openzwave/DNSThread.h
new file mode 100644
index 0000000000..1de524af62
--- /dev/null
+++ b/hardware/openzwave/DNSThread.h
@@ -0,0 +1,101 @@
+//-----------------------------------------------------------------------------
+//
+//	DNSThread.h
+//
+//	Async DNS Lookups
+//
+//	Copyright (c) 2016 Justin Hammond <justin@dynam.ac>
+//
+//	SOFTWARE NOTICE AND LICENSE
+//
+//	This file is part of OpenZWave.
+//
+//	OpenZWave is free software: you can redistribute it and/or modify
+//	it under the terms of the GNU Lesser General Public License as published
+//	by the Free Software Foundation, either version 3 of the License,
+//	or (at your option) any later version.
+//
+//	OpenZWave is distributed in the hope that it will be useful,
+//	but WITHOUT ANY WARRANTY; without even the implied warranty of
+//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//	GNU Lesser General Public License for more details.
+//
+//	You should have received a copy of the GNU Lesser General Public License
+//	along with OpenZWave.  If not, see <http://www.gnu.org/licenses/>.
+//
+//-----------------------------------------------------------------------------
+
+#ifndef _DNSThread_H
+#define _DNSThread_H
+
+#include <string>
+#include <map>
+#include <list>
+
+#include "Defs.h"
+#include "Driver.h"
+#include "platform/Event.h"
+#include "platform/Mutex.h"
+#include "platform/TimeStamp.h"
+#include "platform/DNS.h"
+
+namespace OpenZWave
+{
+	class Event;
+	class Mutex;
+	class Controller;
+	class Thread;
+
+
+	enum LookupType {
+		DNS_Lookup_ConfigRevision = 1
+	};
+
+	struct DNSLookup {
+			uint8 NodeID;
+			string lookup;
+			string result;
+			DNSError status;
+			LookupType type;
+
+	};
+
+
+	/** \brief the DNSThread provides Async DNS lookups for checking revision numbers of
+	 *  Config Files against the official database
+	 */
+	class OPENZWAVE_EXPORT DNSThread
+	{
+			friend class Driver;
+		private:
+			DNSThread(Driver *);
+			virtual ~DNSThread();
+
+			/**
+			 *  Entry point for DNSThread
+			 */
+			static void DNSThreadEntryPoint( Event* _exitEvent, void* _context );
+			/**
+			 *  DNSThreadProc for DNSThread.  This is where all the "action" takes place.
+			 */
+			void DNSThreadProc( Event* _exitEvent );
+
+			/* submit a Request to the DNS List */
+			bool sendRequest(DNSLookup *);
+
+			/* process the most recent request recieved */
+			void processResult();
+
+			Driver*			  m_driver;
+			Mutex*			  m_dnsMutex;
+			list<DNSLookup *> m_dnslist;
+			list<DNSLookup *> m_dnslistinprogress;
+			Event*			  m_dnsRequestEvent;
+			DNS				  m_dnsresolver;
+
+
+	}; /* class DNSThread */
+} /* namespace OpenZWave */
+
+
+#endif
diff --git a/hardware/openzwave/Defs.h b/hardware/openzwave/Defs.h
index b6934fda73..386573b0fa 100644
--- a/hardware/openzwave/Defs.h
+++ b/hardware/openzwave/Defs.h
@@ -33,7 +33,6 @@
 #include <stdint.h>
 
 
-
 // Compilation export flags
 #if (defined _WINDOWS || defined WIN32 || defined _MSC_VER) && (!defined MINGW && !defined __MINGW32__ && !defined __MINGW64__)
 #	if defined OPENZWAVE_MAKEDLL	// Create the dynamic library.
@@ -64,6 +63,22 @@
 #endif
 
 
+#ifdef _MSC_VER
+#define OPENZWAVE_DEPRECATED_WARNINGS_OFF 	__pragma( warning(push) )\
+                                                __pragma( warning(disable: 4996) )
+#else
+#define OPENZWAVE_DEPRECATED_WARNINGS_OFF 	_Pragma ( "GCC diagnostic push" )\
+                                                _Pragma ( "GCC diagnostic ignored \"-Wdeprecated-declarations\"" )
+#endif
+
+#ifdef _MSC_VER
+#define OPENZWAVE_DEPRECATED_WARNINGS_ON 	__pragma( warning(pop) )
+#else
+#define OPENZWAVE_DEPRECATED_WARNINGS_ON 	_Pragma ( "GCC diagnostic pop" )
+#endif
+
+
+
 #ifdef NULL
 #undef NULL
 #endif
@@ -146,14 +161,13 @@ static inline int version_cmp(struct ozwversion a, struct ozwversion b)
 }
 
 #include "OZWException.h"
-#define OPENZWAVE_DISABLE_EXCEPTIONS
 #if defined(_MSC_VER)
 #  define __MYFUNCTION__ __FUNCTION__
 #else
 #  define __MYFUNCTION__ __FILE__
 #endif
-// Exceptions : define OPENZWAVE_DISABLE_EXCEPTIONS in compiler flags to enable exceptions instead of exit function
-#ifndef OPENZWAVE_DISABLE_EXCEPTIONS
+// Exceptions : define OPENZWAVE_ENABLE_EXCEPTIONS in compiler flags to enable exceptions instead of exit function
+#ifdef OPENZWAVE_ENABLE_EXCEPTIONS
 
 #  define OZW_FATAL_ERROR(exitCode, msg)   	Log::Write( LogLevel_Error,"Exception: %s:%d - %d - %s", std::string(__MYFUNCTION__).substr(std::string(__MYFUNCTION__).find_last_of("/\\") + 1).c_str(), __LINE__, exitCode, msg); \
 											throw OZWException(__MYFUNCTION__, __LINE__, exitCode, msg)
@@ -189,6 +203,9 @@ namespace OpenZWave
 #define strcasecmp _stricmp
 #define sscanf sscanf_s
 #define strncpy strncpy_s
+#define strncat strncat_s
+
+
 
 #endif
 
@@ -239,6 +256,7 @@ namespace OpenZWave
 #define TRANSMIT_COMPLETE_FAIL							0x02
 #define TRANSMIT_COMPLETE_NOT_IDLE						0x03
 #define TRANSMIT_COMPLETE_NOROUTE 						0x04
+#define TRANSMIT_COMPLETE_VERIFIED						0x05
 
 #define RECEIVE_STATUS_ROUTED_BUSY						0x01
 #define RECEIVE_STATUS_TYPE_BROAD	 					0x04
@@ -251,6 +269,8 @@ namespace OpenZWave
 #define FUNC_ID_SERIAL_API_GET_CAPABILITIES				0x07
 #define FUNC_ID_SERIAL_API_SOFT_RESET					0x08
 
+#define FUNC_ID_SERIAL_API_SETUP						0x0b
+
 #define FUNC_ID_ZW_SEND_NODE_INFORMATION				0x12
 #define FUNC_ID_ZW_SEND_DATA							0x13
 #define FUNC_ID_ZW_GET_VERSION							0x15
@@ -298,6 +318,23 @@ namespace OpenZWave
 #define FUNC_ID_ZW_SET_PROMISCUOUS_MODE					0xD0	// Set controller into promiscuous mode to listen to all frames
 #define FUNC_ID_PROMISCUOUS_APPLICATION_COMMAND_HANDLER	0xD1
 
+#define FUNC_ID_PROPRIETARY_0                           0xF0
+#define FUNC_ID_PROPRIETARY_1                           0xF1
+#define FUNC_ID_PROPRIETARY_2                           0xF2
+#define FUNC_ID_PROPRIETARY_3                           0xF3
+#define FUNC_ID_PROPRIETARY_4                           0xF4
+#define FUNC_ID_PROPRIETARY_5                           0xF5
+#define FUNC_ID_PROPRIETARY_6                           0xF6
+#define FUNC_ID_PROPRIETARY_7                           0xF7
+#define FUNC_ID_PROPRIETARY_8                           0xF8
+#define FUNC_ID_PROPRIETARY_9                           0xF9
+#define FUNC_ID_PROPRIETARY_A                           0xFA
+#define FUNC_ID_PROPRIETARY_B                           0xFB
+#define FUNC_ID_PROPRIETARY_C                           0xFC
+#define FUNC_ID_PROPRIETARY_D                           0xFD
+#define FUNC_ID_PROPRIETARY_E                           0xFE
+
+
 #define ADD_NODE_ANY									0x01
 #define ADD_NODE_CONTROLLER								0x02
 #define ADD_NODE_SLAVE									0x03
@@ -397,4 +434,43 @@ namespace OpenZWave
 #define COMMAND_CLASS_APPLICATION_STATUS 				0x22
 #define COMMAND_CLASS_HAIL								0x82
 
+/* library types */
+#define ZW_LIB_CONTROLLER_STATIC  						0x01
+#define ZW_LIB_CONTROLLER         						0x02
+#define ZW_LIB_SLAVE_ENHANCED     						0x03
+#define ZW_LIB_SLAVE              						0x04
+#define ZW_LIB_INSTALLER          						0x05
+#define ZW_LIB_SLAVE_ROUTING      						0x06
+#define ZW_LIB_CONTROLLER_BRIDGE  						0x07
+#define ZW_LIB_DUT                						0x08
+
+/* Serial API Setup Commands */
+#define SERIAL_API_SETUP_CMD_TX_STATUS_REPORT			0x02
+#define SERIAL_API_SETUP_CMD_TX_POWERLEVEL_SET 			0x04
+#define SERIAL_API_SETUP_CMD_TX_POWERLEVEL_GET 			0x08
+#define SERIAL_API_SETUP_CMD_TX_GET_MAX_PAYLOAD_SIZE	0x10
+
+/* RouteScheme Definitions */
+typedef enum TXSTATUS_ROUTING_SCHEME
+{
+  ROUTINGSCHEME_IDLE = 0,
+  ROUTINGSCHEME_DIRECT = 1,
+  ROUTINGSCHEME_CACHED_ROUTE_SR = 2,
+  ROUTINGSCHEME_CACHED_ROUTE = 3,
+  ROUTINGSCHEME_CACHED_ROUTE_NLWR = 4,
+  ROUTINGSCHEME_ROUTE = 5,
+  ROUTINGSCHEME_RESORT_DIRECT = 6,
+  ROUTINGSCHEME_RESORT_EXPLORE = 7
+} TXSTATUS_ROUTING_SCHEME;
+
+/* RouteSpeed Definitions */
+typedef enum TXSTATUS_ROUTE_SPEED
+{
+	ROUTE_SPEED_AUTO = 0,
+	ROUTE_SPEED_9600 = 1,
+	ROUTE_SPEED_40K = 2,
+	ROUTE_SPEED_100K = 3,
+} TXSTATUS_ROUTE_SPEED;
+
+
 #endif // _Defs_H
